﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;
using ZedGraph;

namespace WhaleteqPPG_SDK_Demo
{
    class PDSamplingGraph : ZedGraphControl
    {
        private double _timeMax;

        public PDSamplingGraph()
        {
            ScrollGrace = 0;
            ScrollMaxX = 0;
            ScrollMaxY = 0;
            ScrollMaxY2 = 0;
            ScrollMinX = 0;
            ScrollMinY = 0;
            ScrollMinY2 = 0;

            GraphPane GP = GraphPane;
            LineItem M = GP.AddCurve("", new PointPairList(), Color.Blue, SymbolType.None);
            LineItem N = GP.AddCurve("", new PointPairList(), Color.DarkViolet, SymbolType.None);
            GP.Title.Text = "PD Sampling";
            GP.YAxis.Title.Text = "Value";
            GP.XAxis.Title.Text = "Time (ms)";

            _timeMax = 25;

            Axis X = GraphPane.XAxis;
            X.Scale.Max = _timeMax;
            X.Scale.Min = 0;
            X.Scale.MajorStep = _timeMax / 5;
            X.Scale.MinorStep = X.Scale.MajorStep / 5;
            X.MinorGrid.IsVisible = true;
            X.MinorGrid.DashOff = 1;
            X.MinorGrid.DashOn = 5;
            X.MinorGrid.Color = Color.Pink;
            X.MajorGrid.IsVisible = true;
            X.MajorGrid.DashOff = 0;
            X.MajorGrid.DashOn = 10;
            X.MajorGrid.Color = Color.Pink;

            double valueMax = 1024;

            Axis Y = GP.YAxis;
            Y.Scale.Max = valueMax;
            Y.Scale.Min = 0;
            Y.Scale.MajorStep = valueMax / 4;
            Y.Scale.MinorStep = Y.Scale.MajorStep / 2;
            Y.MinorGrid.IsVisible = true;
            Y.MajorGrid.IsVisible = true;
            Y.MinorGrid.Color = Color.Pink;
            Y.MajorGrid.Color = Color.Pink;
            Y.IsAxisSegmentVisible = false;
        }

        private double _SamplingTime = 0.03;
        double s_tg = 0;
        public void Sampling(short[] valueArray)
        {
            for (int i = 0; i < valueArray.Length; i++)
            {
                if ((s_tg += _SamplingTime) > _timeMax)
                {
                    ResetGraph();
                    s_tg = 0;
                }

                GraphPane.CurveList[0].AddPoint(s_tg, valueArray[i]);
            }

            Invalidate();
        }

        public void ResetGraph()
        {
            GraphPane.CurveList[0].Clear();
            GraphPane.CurveList[1].Clear();
        }

    }
}
